let doc = jQuery(document);

doc.ready(function(){
  let profile_heading = jQuery( 'body.wp-admin.profile-php.seller h1.wp-heading-inline' );
  if ( profile_heading.length ) {
    profile_heading.html( 'My User Account' );
  }

  /* let profile_contact = jQuery( 'body.wp-admin.profile-php.seller h2:contains("Contact Info")' );
  if ( profile_contact.length ) {
    profile_contact.remove();
  } */

  let profile_about = jQuery( 'body.wp-admin.profile-php.seller h2:contains("About Yourself")' );
  if ( profile_about.length ) {
    profile_about.remove();
  }

  let profile_tsf = jQuery( 'body.wp-admin.profile-php.seller h2:contains("Authorial Info")' );
  if ( profile_tsf.length ) {
    profile_tsf.remove();
  }


  let product_type = jQuery( '#product-type' );
  let manage_stock = jQuery( '#_manage_stock' );

  let one_of_a_kind = jQuery( '.acf-field[data-name=one_of_a_kind] input[type=checkbox]' );
  if ( one_of_a_kind.length ) {
    if ( one_of_a_kind.attr( 'checked' ) === 'checked' ) {
      let stock = jQuery( '#_stock' );
      let description = jQuery( '.acf-field.one-of-a-kind .description' );
      // set stock input defaults for simple product if one-of-a-kind and the manage-stock option isn't checked
      if ( product_type.val() === 'simple' && manage_stock.attr( 'checked' ) !== 'checked' ) {
        manage_stock.attr( 'checked', 'checked' );
        stock.val( 1 );
        description.append( '<br><br>The "Manage stock" setting has been enabled and stock quantity has been set to 1.' );
      } else if ( product_type.val() === 'variable' ) {
        description.append( '<br><br>Be sure to enable the "Manage stock" setting and set stock quantity for all Variations.' );
      }
    }
  }

  if ( product_type.length ) {
    product_type.on('change', function() {
      if ( product_type.val() === 'external' && manage_stock.attr( 'checked' ) === 'checked' ) {
        manage_stock.click();
      }
    });
  }


  let product_shipping_class_none = jQuery( '#product_shipping_class option[value="-1"]' );
  if ( product_shipping_class_none.length ) {
    product_shipping_class_none.html('Free Shipping');
  }


  if ( typeof( acf ) == 'object' ) {

    let acf_tabs = jQuery('.acf-tab-wrap .acf-tab-button');
    if (location.hash.length>1){
      let hash = location.hash.substring(1);
      acf_tabs.each(function(i, button){
        if (hash === jQuery(button).text().toLowerCase().replaceAll(' ', '-')){
          // if we found a match, click it then exit the each() loop
          jQuery(button).trigger('click');
          return false;
        }
      });
    }
    // when a tab is clicked, update the hash in the URL
    acf_tabs.on('click', function($el){
      location.hash='#'+jQuery(this).text().toLowerCase().replaceAll(' ', '-');
    });

    // add markup to edit seller post screen
    let payouts_box = doc.find('.acf-field.payouts-report');
    payouts_box.append(
      '<div class="acf-input">' +
          '<div id="payouts-report" class="acf-input-wrap">' +
            '<div id="payouts-report-loading"><span>Loading...</span></div>' +
          '</div>' +
        '</div>'
    );

  }


  let payouts_report = null;
  let payouts_report_loading = null;


  // set objects if needed, load report
  function payouts_init_report() {
    if ( payouts_report == null ) {
      payouts_report = jQuery('#payouts-report');
    }
    if ( payouts_report_loading == null ) {
      payouts_report_loading = jQuery('#payouts-report-loading');
    }

    payouts_load_report();
  }


  // load report via ajax, bind events within
  function payouts_load_report() {
    if ( ! payouts_report.length ) {
      return;
    }

    payouts_report_loading.css('opacity','1');
    let report_request_data = {
      'action': 'bt_payouts_report',
    };
    jQuery.extend(report_request_data, report_request_data, bt_ecomm_data);
    jQuery.post(bt_ecomm_data.ajax_url, report_request_data, function(response) {
      payouts_report.html( response );
      payouts_report_loading.css('opacity','0');

      // handle open/close of details
      let payout_report_toggle = jQuery('#payouts-report .toggle');
      payout_report_toggle.on('click', function(e) {
        e.preventDefault();
        let target = jQuery(e.target);
        let year_week = target.data('year_week');
        let open = target.data('open').toString();
        let orders = jQuery('#payouts-report td.orders-' + year_week + ' div');
        if ( open === '0' ) {
          orders.addClass('open');
          target.data('open', '1');
        } else {
          orders.removeClass('open');
          target.data('open', '0');
        }
      });

      // handle admin do payout
      let payout_report_do_payout = jQuery('#payouts-report .do-payout');
      payout_report_do_payout.on('click', function(e) {
        e.preventDefault();
        let target = jQuery(e.target);
        do_seller_payout(target.data());
      });

      jQuery( document.body ).trigger( 'post-load' );
    });
  }


  // front end for sellers
  jQuery('body.page.my-account').ready(function(){
    payouts_init_report();
  });


  // run payout ajax request, alert the response, reload report
  function do_seller_payout(data) {
    let payout_request_data = {
      'action': 'bt_do_payout',
      'user_id': data.user_id,
      'year_week': data.year_week,
      'amount': data.amount,
      'adjustment': data.adjustment,
      'fee_rate': data.fee_rate,
    };
    jQuery.extend(payout_request_data, payout_request_data, bt_ecomm_data);
    console.dir(payout_request_data);
    jQuery.post(bt_ecomm_data.ajax_url, payout_request_data, function(response) {
      alert(response);
      payouts_init_report();
    });
  }


  // welcome email
  jQuery('body.wp-admin.user-edit-php').ready(function() {
    let field_container = jQuery('.acf-field[data-name=received_welcome_email] .acf-input')
    if ( field_container.length ) {
      field_container.append(
        '<p style="padding-top:1rem;">' +
          '<button class="button" type="button" id="send-welcome-email">Reset Password &amp; Send Welcome Email</button>' +
        '</p>'
      );
      jQuery('button#send-welcome-email').on('click', function(e) {
        if (confirm("Are you sure? The user will get a new password and be sent a fresh welcome email (including the password).")) {
          let user_id = jQuery('input#user_id').val();
          let welcome_email_data = {
            'action': 'bt_send_welcome_email',
            'user_id': user_id,
          };
          jQuery.extend(welcome_email_data, welcome_email_data, bt_ecomm_data);
          jQuery.post(bt_ecomm_data.ajax_url, welcome_email_data, function(response) {
            field_container.append('<p><em>' + response + '</em></p>');
            if (response === 'Success!') {
              let field_input = jQuery('.acf-field[data-name=received_welcome_email] input[type=checkbox]')
              field_input.attr('checked', true);
              let field_switch = jQuery('.acf-field[data-name=received_welcome_email] .acf-switch')
              field_switch.addClass('-on');
            }
          });
        }
      });
    }
  });


  // seller contract
  jQuery('body.page.seller-contract').ready(function(){
    let contract_form = jQuery('form#seller-contract');
    if ( contract_form.length ) {
      let contract_form_name = jQuery('input#seller-contract-name');
      let contract_form_button = jQuery('form#seller-contract button');
      let contract_form_result = jQuery('#seller-contract-result');

      contract_form.on('submit',function(e){
        e.preventDefault();
        contract_form_button.click();
      });

      contract_form_button.on('click',function(){
        let contract_data = contract_form_button.data();
        let seller_contract_data = {
          'action': 'bt_agree_to_seller_contract',
          'contract_name_entered': contract_form_name.val(),
          'contract_name_system': contract_data.system_contract_name,
          'contract_date': contract_data.contract_date,
        };
        jQuery.extend(seller_contract_data, seller_contract_data, bt_ecomm_data);
        jQuery.post(bt_ecomm_data.ajax_url, seller_contract_data, function(response) {
          response = JSON.parse(response);
          contract_form_result.html(response.message_html);
          if (response.success) {
            contract_form.remove();
          }
        });
      });
    }
  });


  // seller manual-payouts
  jQuery('body.page.my-account').ready(function(){
    let manual_payouts_button = jQuery('#accept-manual-payouts');
    if ( manual_payouts_button.length ) {
      let step = manual_payouts_button.closest('.step');
      /*let contract_form_button = jQuery('form#seller-contract button');
      let contract_form_result = jQuery('#seller-contract-result');*/

      manual_payouts_button.on('click',function(){
        let manual_payouts_data = {
          'action': 'bt_agree_to_manual_payouts',
        };
        jQuery.extend(manual_payouts_data, manual_payouts_data, bt_ecomm_data);
        jQuery.post(bt_ecomm_data.ajax_url, manual_payouts_data, function(response) {
          response = JSON.parse(response);
          step.append(response.message_html);
          if (response.success) {
            step.addClass('complete').removeClass('pending');
            step.children('p').remove();
            manual_payouts_button.remove();
            step.append('<p class="text-center">Success!</p>');
          }
        });
      });
    }
  });


  // seller requirements
  jQuery('body.wp-admin.post-php').ready(function(){
    let seller_is_approved = jQuery( '.acf-field[data-name=seller_is_approved]' );
    if ( seller_is_approved.length ) {
      let seller_is_approved_container = seller_is_approved.parent();
      let post_id_input = jQuery('input#post_ID');

      let seller_requirements_data = {
        'action': 'bt_seller_requirements',
        'post_id': post_id_input.val(),
      };
      jQuery.extend(seller_requirements_data, seller_requirements_data, bt_ecomm_data);
      jQuery.post(bt_ecomm_data.ajax_url, seller_requirements_data, function(response) {
        seller_is_approved_container.append(response);
      });
    }
  });
});
